# -*- coding:utf-8 -*-

"""
Name: PyMyEditor

Some parts of the code are from myeditor.py by Zen.
      http://home.arcor.de/radioactiveman23/myedit.py
All original "myeditor.py components" have Copyright (c) Zen.
I changed it and added many functions for myself. 
Changed and added components have Copyright (c) masa 2009.
-----------------
This program is free software.This program is distributed 
WITHOUT ANY WARRANTY.You should use it on your own risk. 

You can modify/redistribute it under the terms of the 
GNU General Public License version 2 or later.
"""
__script__ = "PyMyEditor"
__ver__    = "0.05(2)"
__author__ = 'masa'
__web__    = "http://masaland.cocolog-nifty.com/"
__Copyright__ = 'Copyright (c) 2009-2014 masa'
__Copyr__ = '(C) 2010-2014 masa'


import sys
sys.setdefaultencoding('utf-8')
sys.path.insert(0, 'E:\\Python\\lib')

#------options  (can change if you want)-------------------------
pme_ini_file = "E:\\Data\\masa\\PyMyEditor.ini"
open_tmp_text = 0     #when start PyMyEditor without "item" param
                      #0:open blank new file  1:open _pmed_tmp.txt
Encoding = "AUTO"     #default encoding for open file
#Encoding = "UTF-8"   
#Encoding = "UTF-16"
#Encoding = "Shift-JIS"
EkeyYes_menu = 1      #0:disp. insert group menu / 1:disp. menu by timer
ins_menu_time = 0.4   #wait time(sec), use when EkeyYes_menu = 1 
show_LF = 1           #LF(Line Feed) visible option
#NewLine_CR = 0 # if there is text file that has only CR, NewLine_CR = 1
#               # if all text files has LF or CR+LF ,     NewLine_CR = 0
#               # NewLine_CR is effective when show_LF = 1
SJIS_NewLine = 3  #1:CR  2:LF  3:CR+LF  others:CR+LF
UTF_NewLine  = 2  #1:CR  2:LF  3:CR+LF  others:LF
#SJIS_NewLine description ,New_Line character in output file(Shift-JIS)
#UTF_NewLine description  ,New_Line character in output file(UTF-8/UTF-16)


#-------global variables (can change if you want)----------------
#display on tilte bar
Enc_title_list = {"UTF-8":"u8", "UTF-16":"u6", "Shift-JIS":"sj"} 
Week_list = ["（日）","（月）","（火）","（水）","（木）","（金）","（土）"]
#Week_list = ["(Sun)","(Mon)","(Tue)","(Wed)","(Thu)","(Fri)","(Sat)"]
Date_form = "%Y-%m-%d" #e.g. 2009-05-22   "%Y/%m/%d" e.g. 2009/05/22

#-------global variables (no need to change)----------------------
JP_CODECS = 0
FBUIUTIL = 0
#about *1: don't change this order (import/date_text/insert_menu1/2)
import time   #*1
date_text = time.strftime(Date_form, time.localtime()) + \
            Week_list[int(time.strftime("%w", time.localtime()))]   #*1

#-------global variables (can change if you want)----------------
ins_menu1_name = "python code" #insert words group name(use for menu)
ins_menu2_name = "web / blog"  #insert words group name(use for menu)
# ins_menu1/2 [<menu item>, <insert body>, <increase cursor value>] 
ins_menu1 = [
      ["indent", "    ", 4],
      ["def declaration", "def ():\n    \n    ", 4],
      ["class declaration", "class :\n    def __init__(self):\n    \n    ", 6],
      ["for cycle", "for in :\n    \n    ", 4],
      ["for i in range cycle", "for i in range(, ):\n    \n", 15],
      ["if else", "if :\n    \nelse:\n    \n", 3],
      ["elif", "elif :\n    \n", 5],
      ["main function", "if __name__ == \"__main__\":\n  main()", 34],
      ["import", "import ", 7],
      ["import all", "from  import *", 5]
      ]   #*1

ins_menu2 = [
      ["web left align", " align=\"left\" hspace=\"10\" ", 26],
      ["web br clear=all", "<br clear=\"all\">　<br>", 21],
      ["date", date_text, 13]
      ]   #*1

#-------------

import os
import appuifw
import e32
import re
#import codecs
from key_codes import EKeyYes
from key_codes import EKeyLeftFunc
from key_codes import EKeyEnter
from key_codes import EKeyBackspace
from key_codes import EKeyLeftArrow
from key_codes import EKeyRightArrow
from key_codes import EKeyUpArrow
from key_codes import EKeyDownArrow


try:
    import japanese
    JP_CODECS = 1
except:
    if Encoding.upper() == "SHIFT-JIS":
      Encoding = "UTF-8"
    JP_CODECS = 0

try:
    from PyFbuiutil import Fbrowser
    from PyFbuiutil import Getpath
    FBUIUTIL = 1
except:
    FBUIUTIL = 0

def conf_read():
    global pme_ini_file
    global open_tmp_text
    global Encoding
    global EkeyYes_menu
    global ins_menu_time
    global show_LF
#    global NewLine_CR
    global SJIS_NewLine
    global UTF_NewLine

    FData = 'Dummy Dummy'
    try:
        F = open(pme_ini_file,'r')
        try:
            FData = F.read()
        finally:
            F.close()
    except:
        pass

    #split by \n and omit line that contain only (CR/LF)
    lnDatalist = [x for x in FData.split("\n") if len(x) > 1]

    for lnData in lnDatalist:
        lnDatawk = re.sub("[ \t]+"," ",lnData)
        lnDatawk = (re.sub("[\n\r]+","",lnDatawk)).strip()
        confData = lnDatawk.split(" ")
        if   len(confData) < 2: continue # no confData[1] line
        elif confData[0] == "open_tmp_text" : open_tmp_text = int(confData[1])
        elif confData[0] == "Encoding" : Encoding = confData[1]
        elif confData[0] == "EkeyYes_menu" : EkeyYes_menu = int(confData[1])
        elif confData[0] == "ins_menu_time" : ins_menu_time = float(confData[1])
        elif confData[0] == "show_LF"      : show_LF = int(confData[1])
#        elif confData[0] == "NewLine_CR"   : NewLine_CR = int(confData[1])
        elif confData[0] == "SJIS_NewLine" : SJIS_NewLine = int(confData[1])
        elif confData[0] == "UTF_NewLine"  : UTF_NewLine = int(confData[1])


class myeditor:
    def __init__(self):
        self.script_lock = e32.Ao_lock()
        self.last_find=""
        self.path = ""         #name of file edited now
        self.sel_start = None  #start point of selected word(s)
        self.sel_end   = None  #end point of selected word(s)
        self.sel_clipbd = ''
        self.enc_on_title = ''
        self.Enc = ''
        self.ins_menu_count = 0
        self.menu_list = []
        self.text_bak = ''
        self.curr_dir = ''    #dir path of file edited now
        self.UTF8_BOM_Flg = 0
        self.replace_decode = '' #encoding when decode text that has error char
        self.lf_arw_timer = e32.Ao_timer()
        self.cursor_timer = e32.Ao_timer()


    def run(self, item=None):
        global Encoding
        global open_tmp_text
        global Enc_title_list
        global FBUIUTIL
        global pme_ini_file
        if os.path.exists(pme_ini_file):
            conf_read() #*
        if FBUIUTIL == 1: self.Gpath = Getpath()
        if Encoding.upper() == "AUTO": self.Enc = "UTF-8"
        else: self.Enc = Encoding
        self.enc_on_title = Enc_title_list[self.Enc]

        old_body = appuifw.app.body #*0052
        old_menu = appuifw.app.menu #*0052
        old_handler = appuifw.app.exit_key_handler #*0052
        old_title = appuifw.app.title
        appuifw.app.title = unicode(__script__)
        self.textbody = appuifw.Text()
        self.menu_list = self.make_menu()
        self.refresh()

        self.open_setdata(item=item) #make new file or open file
#        appuifw.app.screen = "full" #*0052

        self.script_lock.wait()

        self.rot_clear()  #*0052
        appuifw.app.title = old_title
        appuifw.app.body = old_body #*0052
#        appuifw.app.body = None
        del self.textbody #*0052
        appuifw.app.menu = old_menu #*0052
        appuifw.app.exit_key_handler = old_handler #*0052
        e32.ao_yield() # 画面反映 #*0052


    def refresh(self):
        appuifw.app.body = self.textbody
        self.textbody.font = 'dense'   # small
        self.textbody.color = 0x000000
        appuifw.app.menu = self.menu_list
        appuifw.app.exit_key_handler = self.check_exit
        self.textbody.bind(EKeyYes,self.ekeyyes_showmenu) 
        self.textbody.bind(EKeyLeftFunc, lambda: self.start_lf_arw_timer(1)) 
        self.textbody.bind(EKeyEnter, lambda: self.start_lf_arw_timer(1)) 
        self.textbody.bind(EKeyBackspace, lambda: self.start_lf_arw_timer(0)) 
        self.textbody.bind(EKeyLeftArrow,  lambda: self.start_cursor_timer(0))
        self.textbody.bind(EKeyRightArrow, lambda: self.start_cursor_timer(1))
        self.textbody.bind(EKeyUpArrow,    lambda: self.start_cursor_timer(0))
        self.textbody.bind(EKeyDownArrow,  lambda: self.start_cursor_timer(0))


    def rot_clear(self): #*0052
        appuifw.app.orientation='automatic'
        appuifw.app.screen = 'normal'


    def rot_screen(self): #*0052
        # flag 0:Automatic   1:Portrait   2:landscape
        #      3:Normal size 4:Full size
        m = [u'automatic rot.', u'portrait', u'landscape', u'normal screen', u'full screen']
        i=appuifw.popup_menu(m)
        if (i != None) and (i<5):
            scr = ['automatic', 'portrait', 'landscape', 'normal', 'full']
            if i < 3:
                appuifw.app.orientation = scr[i]
            else:
                appuifw.app.screen = scr[i]


    def make_menu(self):
        global JP_CODECS
        global FBUIUTIL
        global ins_menu1
        global ins_menu2
        global ins_menu1_name
        global ins_menu2_name
        m_new    = (u'New',self.open_new)
        m_open   = (u'Open',self.open_file)
        m_open_rep = (u'Open as (code sel)', self.show_openas_menu)
        m_save   = (u'Save',self.save)
        m_saveas = (u'Save as',self.save_as)
        m_saveas_code = (u'Save as (code sel)', self.show_saveas_menu)
        if JP_CODECS == 1 and FBUIUTIL == 1: #japanese and PyFbuiutil
            menu_list1 = [
              (u'File', (
                m_new, m_open, m_open_rep, m_save, m_saveas,m_saveas_code
              ))]
        elif JP_CODECS == 1 and not FBUIUTIL == 1:#japanese and no PyFbuiutil
            menu_list1 = [
              (u'File', (
                m_new, m_save, m_saveas, m_saveas_code
              ))]
        elif not JP_CODECS == 1 and FBUIUTIL == 1:#no japanese and PyFbuiutil
            menu_list1 = [
              (u'File', (
                m_new, m_open, m_open_rep, m_save, m_saveas, m_saveas_code
              ))]
        else: #no japanese and no PyFbuiutil
            menu_list1 = [
              (u'File', (
                m_new, m_save, m_saveas, m_saveas_code
              ))]

        menu_list2 = [
              (u"Edit", (
                (u"Select(start,end)", self.select_select),
                (u"Copy", self.select_copy),
                (u"Cut", self.select_cut),
                (u"Paste", self.select_paste),
                (u"Cancel select", self.select_cancel)
              )),
              (u"Insert menu", (
                (unicode(ins_menu1_name), lambda: self.showmenu(ins_menu1)),
                (unicode(ins_menu2_name), lambda: self.showmenu(ins_menu2))
              )),
              (u'Find', (
                (u'Find', self.find),
                (u'Find next', lambda: self.find(text=self.last_find)),
                (u'Find all', self.find_all),
                (u'Find all again', lambda: self.find_all(text=self.last_find))
              )),
              (u'Go to...', (
                (u'Top',self.go_top),
                (u'Last',self.go_last)
              )),
              (u'Screen option', self.rot_screen),
              (u'About', self.about),
              (u'Exit', self.check_exit)]
        return menu_list1 + menu_list2


    def do_exit(self):
        self.exit_key_handler()

    def check_exit(self): #*1
        if self.check_text_discard(msg=u"Really exit?", checkexit=True):
            self.exit_key_handler()

    def exit_key_handler(self):
        appuifw.app.exit_key_handler = None
        self.script_lock.signal()


    def check_text_discard(self, msg='', checkexit=None):
        text = self.textbody.get()
        if self.path == None and len(text) < 1: #new empty text
            rtn = True
        elif not checkexit and text == self.text_bak: # text not changed
            rtn = True
        else:
            if appuifw.query(msg + u"\ndata already saved?",'query'):
                rtn = True
            else:
                rtn = False
        return rtn


    def show_er_val(self):
        import sys
        type, value = sys.exc_info() [:2]
        #appuifw.note(unicode(str(type)+'\n'+str(value)), 'error')
        rtn = appuifw.query(unicode(str(type)+'\n'+str(value)), 'query')


    def open_file(self, replace_decode=''):
        global FBUIUTIL
        if not FBUIUTIL == 1: return #would be a bug if coming here
        self.replace_decode = replace_decode #UTF-8/UTF-16/Shift-JIS/''

        rtn = self.check_text_discard(msg=u"Really open new file?")
        if rtn: #yes open new file
            if self.curr_dir :
                dir_path = self.curr_dir
            elif self.path :
                dir_path = os.path.split(self.path)[0]
            else:
                dir_path = None

            old_screen = appuifw.app.screen
            appuifw.app.screen = 'normal' #*0052
            open_path = self.Gpath.get_read_path(default_path = dir_path)
            appuifw.app.screen = old_screen
            if open_path:
                self.open_setdata(item=open_path)
            else:
                self.refresh()
        self.replace_decode = ''


    def open_new(self):
        global Encoding
        global open_tmp_text
        global Enc_title_list
        rtn = self.check_text_discard(u"Really make new text?")
        if not rtn:
            return #cancel

        #self.last_find=""
        self.sel_start = None
        self.sel_end   = None
        #self.sel_clipbd = ''
        self.path = None
        if Encoding.upper() == "AUTO": self.Enc = "UTF-8"
        else: self.Enc = Encoding
        self.enc_on_title = Enc_title_list[self.Enc]

        self.open_setdata(item=None, new=True)


    def open_setdata(self, item=None, new=None):
        """open file and set data"""
        #change screen for waiting
        self.textbody.set(u'  File open....')
        self.textbody.set_pos(0)
        e32.ao_yield() #necessary for change display

        self.UTF8_BOM_Flg = 0

        if item and os.path.isfile(item):
            self.path = unicode(item)
            text_data = self.open_text()
        elif new: #from open_new
            self.path = None
            text_data = u''
        elif open_tmp_text == 1:
            new_item = self.new_text() #get new_text_file path
            if new_item and os.path.isfile(new_item): #Already exist ?
                self.path = unicode(new_item)
                text_data = self.open_text()
            else:
                self.path = None
                text_data = u''
        else: #new empty file
            self.path = None
            text_data = u''
        self.textbody.set(text_data)
        self.textbody.set_pos(0)
        self.text_bak = self.textbody.get() #make copy for discard check
        e32.ao_yield()
        if self.path == None: file_title = u'New_text'
        else: 
            file_title = unicode(os.path.basename(self.path))
            self.curr_dir = os.path.split(self.path)[0]
        appuifw.app.title = self.enc_on_title + u" " + file_title
        self.refresh()


    def open_text(self):
        global JP_CODECS
        global Enc_title_list
        global show_LF
        global Encoding
        # dummy data,use when reading failed
        if show_LF:
            new_data  = u"\u21b2"+u"\n"
        else:
            new_data  = u"\n"

        try:
            F = open(self.path,'r')
            try:
                text_data = F.read()
            finally:
                F.close()
        except:
            self.show_er_val()
            self.path = None #protect item file from over write
            return new_data

        """ Check BOM Flg (for UTF-8 text) """
        if  ord(text_data[0]) == 0xef and \
            ord(text_data[1]) == 0xbb and \
            ord(text_data[2]) == 0xbf :
            self.UTF8_BOM_Flg = 1

        """Check encoding"""
        if self.replace_decode:
            enc_list = [self.replace_decode]
        else:
            if Encoding.upper() == "AUTO":
                if JP_CODECS == 1:
                    enc_list = ["UTF-8", "Shift-JIS", "UTF-16"]
                else:
                    enc_list = ["UTF-8", "UTF-16"]
            else:
                enc_list = [Encoding]
        for enc in enc_list:
            try:
                if self.replace_decode:
                    new_data = text_data.decode(enc, 'replace')
                else:
                    new_data = text_data.decode(enc)
                if show_LF:
                    wkc = u"\u21b2"+u"\u2029"
                    new_data = new_data.replace(u"\u2029", wkc) #*052 don't move from 1st.
                    new_data = new_data.replace(u"\u2028", wkc) #*052 do not change this -
                    new_data = new_data.replace(u"\r\n"  , wkc) #*052  -conversion order.
                    new_data = new_data.replace(u"\n"    , wkc) #*052 
                    new_data = new_data.replace(u"\r"    , wkc) #*052 
                else:
                    wkc = u"\u2029"
                    new_data = new_data.replace(u"\r\n"  , wkc) #*052 do not change this -
                    new_data = new_data.replace(u"\n"    , wkc) #*052  -conversion order.
                    new_data = new_data.replace(u"\r"    , wkc) #*052 
                    new_data = new_data.replace(u"\u2028", wkc) #*052 
                self.Enc = enc
                self.enc_on_title = Enc_title_list[self.Enc]
                break
            except:
                pass
        else:
            #appuifw.note(unicode("Decoding Error\nOpen new file"), "error")
            self.show_er_val()
            self.path = None #protect item file from over write
            self.enc_on_title = Enc_title_list[self.Enc]
            new_data = u"\n"
        return new_data


    def text_encode(self, encoding):
        global show_LF
        global SJIS_NewLine
        global UTF_NewLine
        old_title = appuifw.app.title
        appuifw.app.title = u"please wait..."
        e32.ao_yield() #necessary for changing display
        try:
            text = self.textbody.get()
            text = text.replace(u"\u2028", u"\u2029") #*0052
            if show_LF:
#                text = text.replace(u"\u21b2", u"")  #*0052
                text = text.replace(u"\u21b2"+u"\u2029", u"\u2029")  #*0052
            if encoding.upper() == "UTF-8"or encoding.upper() == "UTF-16":
                if UTF_NewLine == 2: # LF
                    text = text.replace(u"\u2029", u"\n")
                elif UTF_NewLine == 1: # CR
                    text = text.replace(u"\u2029", u"\r")
                elif UTF_NewLine == 3: # CR+LF
                    text = text.replace(u"\u2029", u"\r\n")
                else: # otehrs -> LF
                    text = text.replace(u"\u2029", u"\n")
                text = text.replace(u"\uFF5E", u"\u301C")
                text = text.encode(encoding)
                if encoding.upper() == "UTF-8" and self.UTF8_BOM_Flg :
                    text = chr(0xEF) + chr(0xBB) + chr(0xBF) + text
            else: #Shift-JIS
                if SJIS_NewLine == 3: # CR+LF
                    text = text.replace(u"\u2029", u"\r\n")
                elif SJIS_NewLine == 1: # CR
                    text = text.replace(u"\u2029", u"\r")
                elif SJIS_NewLine == 2: # LF
                    text = text.replace(u"\u2029", u"\n")
                else: # otehrs -> CR+LF
                    text = text.replace(u"\u2029", u"\r\n")
                text = text.replace(u"\uFF5E", u"\u301C") #wave line
                text = text.replace(u"\uFF0D", u"\u30FC") #hyphen
                text = text.encode("japanese.Shift-JIS")
        except:
            #appuifw.note(unicode("Encoding Error\ntext not saved"), "error")
            self.show_er_val()
            text = None
        appuifw.app.title = old_title
        return text


    def save_as_u8(self, BOM=0):
        if BOM:
            self.UTF8_BOM_Flg = 1
        else:
            self.UTF8_BOM_Flg = 0
        self.save_as('UTF-8')


    def save(self):
        if self.path == None:
            self.save_as()
            return
        text = self.text_encode(self.Enc)
        if text == None: #encode error occurred
            return

        try:
            F = open(self.path,'wb')
            try:
                F.write(text)
            finally:
                F.close()
        except:
            self.show_er_val()
            return
        self.text_bak = self.textbody.get() #make copy for discard check


    def save_as(self, encoding=None):
        global FBUIUTIL
        global Enc_title_list
        if encoding == None: #from save_as menu
            text = self.text_encode(self.Enc)
        else:                #from save_as(UTF-8/16)/(Shift-JIS) menu
            text = self.text_encode(encoding)
        if text == None: #encode error occurred
            return

        if self.path == None:
            save_path = unicode(self.new_text())
        else:
            save_path = self.path

        wk = os.path.split(save_path)
        path = wk[0]
        file = wk[1]

        if FBUIUTIL == 1:
            old_screen = appuifw.app.screen
            appuifw.app.screen = 'normal' #*0052
            save_dest = self.Gpath.get_write_path(title='File name', \
                         default_path=path, msg_ex=file)
            appuifw.app.screen = old_screen
            if save_dest == None:
                self.refresh()
                return #self.path don't change

        else:
            new_name = unicode(file)
            new_name = appuifw.query(u"New name" , "text", new_name)
            if new_name == None:
                return #self.path don't change
            save_dest = os.path.join(path, new_name)

            while True:
              if os.path.exists(save_dest):
                rtn = appuifw.query(u"File exists. Over write ?\n" + new_name, \
                                     "query")
                if rtn:  #Over write
                  break
                else:  #Ask new_name
                  new_name = appuifw.query(u"File exists. Give a new name!" ,\
                          "text", new_name)
                  if new_name == None:
                      break
                  save_dest = os.path.join(path, new_name)
              else:
                break #new_name OK
            if new_name == None: return #self.path don't change

        self.refresh() #recover menu
        try:
            F = open(save_dest,'wb')
            try:
                F.write(text)
            finally:
                F.close()
        except:
            self.show_er_val()
            return #self.path don't change

        self.text_bak = self.textbody.get() #make copy for discard check
        if not encoding == None: #text encoding was changed (saved text)
            """reopen new (saved) text"""
            #self.last_find=""
            self.sel_start = None
            self.sel_end   = None
            #self.sel_clipbd = ''
            self.Enc = encoding
            self.enc_on_title = Enc_title_list[self.Enc]
        self.path = unicode(save_dest)
        file_title = unicode(os.path.basename(self.path))
        self.curr_dir = os.path.split(self.path)[0]
        appuifw.app.title = self.enc_on_title + u" " + file_title
        self.refresh()


    def new_text(self):
        if os.path.exists('E:\\Data')  : new_path = 'E:\\Data\\_pmed_tmp.txt'
        elif os.path.exists('C:\\Data'): new_path = 'C:\\Data\\_pmed_tmp.txt'
        elif os.path.exists('E:\\')    : new_path = 'E:\\_pmed_tmp.txt'
        else:                            new_path = 'C:\\_pmed_tmp.txt'
        return new_path


    def start_lf_arw_timer(self, flg):
        if show_LF:
            self.lf_arw_timer.cancel()
            self.lf_arw_timer.after(0.003, lambda:self.lf_arrow(flg))


    def lf_arrow(self, flg):
        #flg 0:clear  1:insert LF/Char
        cur_pos = self.textbody.get_pos()
        if cur_pos == 0:
            return
        wk1 = self.textbody.get(cur_pos - 1, 1)
        if flg: # insert
            if wk1 == u"\u2029":
                self.textbody.set_pos(cur_pos - 1)
                self.textbody.add(u"\u21b2")
                self.textbody.set_pos(cur_pos + 1)
        else: # clear LF/Char
            if wk1 == u"\u21b2":
                self.textbody.delete(cur_pos - 1, 1)


    def start_cursor_timer(self, flg):
        if show_LF:
            self.cursor_timer.cancel()
            self.cursor_timer.after(0.003, lambda:self.cur_control(flg))


    def cur_control(self, flg):
        #flg  1:right  0:left/up/down
        cur_pos = self.textbody.get_pos()
        text_len = len(self.textbody.get())
        if cur_pos == 0 or cur_pos == text_len:
            return
        wk1 = self.textbody.get(cur_pos - 1, 1)
        wk2 = self.textbody.get(cur_pos , 1)
        if wk1 == u"\u21b2" and wk2 == u"\u2029":
            if flg:
                self.textbody.set_pos(cur_pos + 1)
            else:
                self.textbody.set_pos(cur_pos - 1)


    def about(self):
        msg =     (__script__) \
         + '\n' + ('Ver_' + __ver__) \
         + '\n' + (__Copyr__) \
         + '\n' + (__web__ )
        appuifw.query(unicode(msg, "utf-8"), "query")


    def go_top(self):
        self.textbody.set_pos(0)

    def go_last(self):
        text = self.textbody.get()
        self.textbody.set_pos(len(text))


    def get_find_word(self, pos):
        if self.sel_end != None and self.sel_start != None and \
                self.sel_end != self.sel_start:
            sel_len = self.sel_end - self.sel_start
            example_wd = self.textbody.get(self.sel_start, sel_len)
            curr_pos = self.sel_start #back to first point
            """clear highlight"""
            self.select_redraw(self.sel_start, self.sel_end)
            self.sel_start = None
            self.sel_end   = None
        else:
            curr_pos = pos
            example_wd = self.last_find
        f = appuifw.query(u"Find text:",'text', example_wd)
        return f, curr_pos


    def find(self, text="", offset=True):
        if offset: pos_offset = 1 #searc start point offset
        else:      pos_offset = 0

        curr_pos = self.textbody.get_pos()
        t = self.textbody.get()
        if not t:
            appuifw.note(u"no text",'info')
            return

        if text == "": 
            f, curr_pos = self.get_find_word(curr_pos)
        else:
            f = self.last_find
        if not f: return #cancel
        self.last_find = f

        pattern = re.compile(f, re.I)
        m_start = pattern.search(t, curr_pos + pos_offset)

        if m_start == None:
            if appuifw.query(u"Not found. Go to begin?",'query'):
                self.textbody.set_pos(0)
                self.find(text=f, offset=None)
        else:
            pos_start = m_start.start()
            self.textbody.set_pos(pos_start)


    def find_all(self, text=""):
        curr_pos = self.textbody.get_pos()
        t = self.textbody.get()
        if not t:
            appuifw.note(u"no text",'info')
            return

        if text == "": 
            f, curr_pos = self.get_find_word(curr_pos)
        else:
            f = self.last_find
        if not f: return #cancel
        self.last_find = f

        pattern = re.compile(f, re.I)

        start_list = []
        #end_list = []
        result_list = []
        find_list = pattern.finditer(t, 0)  #find all

        for x in find_list: #call iter. and get result one by one
            r_p = x.start()                       #position
            start_list.append(r_p)
            #end_list.append(x.end())
            if r_p < 3:
                r_t = t[0:12]     #text partial
            else:
                r_t = t[r_p-2:r_p+12]     #text partial
            r_t = (re.sub(u"[ \t\n\r]*", u"", r_t)).strip()
            r_t = (re.sub(unichr(0x2029), u"", r_t)).strip()
            result_list.append(str(r_p)+u": "+r_t)  #menu list

        if result_list == []: #don't use start_list for check
            appuifw.query(u"Not found.",'query')
            return

        r_n = appuifw.popup_menu(result_list, u'Slelct to go (Find all)')
        if r_n == None: return #cancel
        else:           self.textbody.set_pos(start_list[r_n])


    def showmenu(self, menulist):
      m = [unicode(x[0]) for x in menulist]
      i=appuifw.popup_menu(m)
      if i!=None:
        pos = self.textbody.get_pos()
        text2 = menulist[i][1]
        pos_inc = int(menulist[i][2])
        self.textbody.add(unicode(text2))
        self.textbody.set_pos(pos + pos_inc)


    def ins_menu_timer(self):
        global ins_menu1
        global ins_menu2
        i = self.ins_menu_count
        self.ins_menu_count = 0
        if   i == 1:self.showmenu(ins_menu1)
        else       :self.showmenu(ins_menu2)


    def ekeyyes_showmenu1(self):
        global ins_menu_time
        if self.ins_menu_count == 0:
            self.timer = e32.Ao_timer()
            self.timer.after(ins_menu_time, lambda:self.ins_menu_timer())
        self.ins_menu_count = self.ins_menu_count + 1


    def ekeyyes_showmenu0(self):
        global ins_menu1_name
        global ins_menu2_name
        global ins_menu1
        global ins_menu2
        m = [unicode(ins_menu1_name), unicode(ins_menu2_name)]
        i=appuifw.popup_menu(m)
        if i!=None:
            if   i == 0:self.showmenu(ins_menu1)
            elif i == 1:self.showmenu(ins_menu2)


    def ekeyyes_showmenu(self):
        global EkeyYes_menu
        if EkeyYes_menu == 0:self.ekeyyes_showmenu0()
        else:                self.ekeyyes_showmenu1()


    def show_openas_menu(self):
        if JP_CODECS == 1:
            m = [u'Open as (utf-8)', u'Open as (utf-16)', u'Open as (s-jis)']
        else:
            m = [u'Open as (utf-8)', u'Open as (utf-16)']
        i=appuifw.popup_menu(m)
        if i != None:
            if   i == 0: self.open_file('UTF-8')
            elif i == 1: self.open_file('UTF-16')
            elif i == 2: self.open_file('Shift-JIS')


    def show_saveas_menu(self):
        if JP_CODECS == 1:
            m = [u'Save as (utf-8/no BOM)', u'Save as (utf-8/BOM)', u'Save as (utf-16)',
                 u'Save as (s-jis)']
        else:
            m = [u'Save as (utf-8/no BOM)', u'Save as (utf-8/BOM)', u'Save as (utf-16)']
        i=appuifw.popup_menu(m)
        if i != None:
            if   i == 0: self.save_as_u8(BOM=0)
            elif i == 1: self.save_as_u8(BOM=1)
            elif i == 2: self.save_as('UTF-16')
            elif i == 3: self.save_as('Shift-JIS')


    def select_highlight(self):
        """Highlight selected word(s)"""
        text = self.textbody
        sel_len = self.sel_end - self.sel_start
        cb_txt = text.get(self.sel_start, sel_len)
        """highlight selected text"""
        old_style = text.style
        text.style = appuifw.HIGHLIGHT_STANDARD
        #text.highlight_color = 0xffff00
        text.set_pos(self.sel_start) #*3
        text.delete(self.sel_start, sel_len)
        text.set_pos(self.sel_start)
        text.add(cb_txt)
        text.style = old_style

        """necessary to reflect the highlight correctly"""
        old_body = appuifw.app.body #*2 
        appuifw.app.body = old_body #*2


    def select_redraw(self,start_pos, end_pos):
        """Clear highlight"""
        text = self.textbody
        cur_pos = text.get_pos()
        sel_len = end_pos - start_pos
        cb_txt = text.get(start_pos, sel_len)
        text.set_pos(start_pos) #*3
        text.delete(start_pos, sel_len)
        text.set_pos(start_pos)
        text.add(cb_txt)
        text.set_pos(cur_pos)


    def select_select(self):
        """Select Start/End"""
        text = self.textbody
        if self.sel_start == None: #sel start
            self.sel_start = text.get_pos()
            return                      #end of normal case
        if self.sel_end == None:
            self.sel_end = text.get_pos()
            if self.sel_start == self.sel_end:
                appuifw.note(u"Select again, same point selected", "info")
                self.sel_end = None
                return # need select again end point
            if self.sel_start > self.sel_end:
                self.sel_start, self.sel_end = self.sel_end, self.sel_start
            self.select_highlight() # highlight selected word(s)
            return #selected

        cur_pos = text.get_pos()
        if self.sel_start == cur_pos or self.sel_end == cur_pos:
            appuifw.note(u"Same point selected", "info")
            return # same point selected

        if cur_pos < self.sel_start:
            old_sel_start = self.sel_start
            self.sel_start = text.get_pos()
            """clear highlight"""
            self.select_redraw(old_sel_start, self.sel_end)
            self.select_highlight() # highlight selected word(s)
        else:
            old_sel_end = self.sel_end
            self.sel_end = text.get_pos()
            """clear highlight"""
            self.select_redraw(self.sel_start, old_sel_end)
            self.select_highlight() # highlight selected word(s)

    def select_cancel(self):
        """Cancel select"""
        text = self.textbody
        if self.sel_end != None and self.sel_start != None and \
                               self.sel_end != self.sel_start:
            """clear highlight"""
            self.select_redraw(self.sel_start, self.sel_end)
        self.sel_start = None
        self.sel_end   = None
        #self.sel_clipbd = ''

    def select_copy(self):
        """Copy"""
        text = self.textbody
        if self.sel_end == None or self.sel_start == None or \
                self.sel_end == self.sel_start:
            appuifw.note(u"Select word(s) before Copy", "info")
            return
        sel_len = self.sel_end - self.sel_start
        self.sel_clipbd = text.get(self.sel_start, sel_len) #copy to clipbd
        """clear highlight"""
        self.select_redraw(self.sel_start, self.sel_end)

        self.sel_start = None
        self.sel_end   = None

    def select_cut(self):
        """Cut"""
        text = self.textbody
        if self.sel_end == None or self.sel_start == None or \
                             self.sel_end == self.sel_start:
            appuifw.note(u"Select word(s) before Cut", "info")
            return
        sel_len = self.sel_end - self.sel_start
        self.sel_clipbd = text.get(self.sel_start, sel_len)
        text.set_pos(self.sel_start) #*3
        text.delete(self.sel_start, sel_len)
        text.set_pos(self.sel_start) #*3
        #redraw(text)
        self.sel_start = None
        self.sel_end   = None


    def select_paste(self):
        """Paste"""
        text = self.textbody
        if self.sel_clipbd:
            text.add(self.sel_clipbd)
        else:
            appuifw.note(u"Copy before paste", "info")


def main():
#    if os.path.exists(pme_ini_file):
#        conf_read()                  #move to 'run' module
    #import sys
    if len(sys.argv) > 1:
        item = sys.argv[1]    #get file_name from argv
    else:
        item = None
    """check item then open or make new file, proc is in myeditor"""
    Ed = myeditor()
    Ed.run(item)

if __name__ == '__main__': main()

#appuifw.app.set_exit()
#sys.exit()

